/**
 * Javier Abelln, 23 Mayo 2006
 */
package chuidiang.pruebas;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import chuidiang.paneles.EditorHtml;

/**
 * Applet y main de prueba del EditorHtml
 * 
 * @author Chuidiang
 */
public class PruebaEditorHtml extends JApplet
{
    /**
     * serial uid
     */
    private static final long serialVersionUID = 4049642308209162291L;
    
    /** Para escribir la url que se quiere ver */
    private JTextField editorUrl;
    
    /** Componente en el que se ve la pgina html */
    private EditorHtml visorHtml;
    
    /** Panel que contiene el textField para la url y el botn de ir a ella */
    private JPanel panelDeControl;
    
    /** Botn para ver la pgina html que se puesto en el textField */
    private JButton botonIr;
    
    /** Scroll para el visor de html */
    private JScrollPane scroll;
    
    /** Panel que lo contiene todo */
    private JPanel panelPrincipal;

    /** inicializa el applet, contruyendo todo y fijando una pgina inicial */
    public void init()
    {
        creaTodo(this);
    }

    /**
     * main de prueba. Crea un JFrame y lo mete todo dentro.
     * @param args
     */
    public static void main(String[] args)
    {
        PruebaEditorHtml editor = new PruebaEditorHtml();
        JFrame ventana = new JFrame();
        editor.creaTodo(ventana.getContentPane());
        ventana.pack();
        ventana.setVisible(true);
    }

    /**
     * Construye el panel con un visor de html y una pequea barra de
     * herramientas.
     * @param contenedor Donde se debe meter todo
     */
    private void creaTodo(Container contenedor)
    {
        creaPanelDeControl();
        creaVisorHtml();
        anhadeTodoAlContenedor(contenedor);
        botonIr.addActionListener(irA);
        editorUrl.addActionListener(irA);
    }

    /**
     * Listener para el textField con la url y para el botn de ir.
     * Pulsando enter en el textField o pulsando el botn, se pasa la pagina
     * que contiene el textField al visor de html.
     * Muestra un dialogo de error si la url escrita no es vlida.
     */
    private ActionListener irA = new ActionListener()
    {
    
        public void actionPerformed(ActionEvent e)
        {
            try
            {
                visorHtml.setPage(editorUrl.getText());
            }
            catch (Exception e2)
            {
                muestraMensajeError();
            }
        }
    
    };

    /**
     * Instancia el EditorHtml y le pone una pgina inicial.
     */
    private void creaVisorHtml()
    {
        visorHtml = new EditorHtml();
        try
        {
            visorHtml.setPage("http://www.chuidiang.com");
        } catch (Exception e)
        {
            muestraMensajeError();
        }
        
    }

    /** Muestra una ventana de error si la url tecleada es incorrecta */
    private void muestraMensajeError()
    {
        JOptionPane.showMessageDialog(
                SwingUtilities.getWindowAncestor(this),
                        "URL incorrecta. Por favor, escrbela de nuevo",
                        "URL erronea",
                        JOptionPane.ERROR_MESSAGE);
    }

    /**
     * Mete el panel de control y el visor de html con su correspondiente
     * scroll en el contenedor que se le pasa.
     * @param contenedor El contenedor donde se quiere construir todo.
     */
    private void anhadeTodoAlContenedor(Container contenedor)
    {
        scroll = new JScrollPane();
        panelPrincipal = new JPanel(new BorderLayout());
        panelPrincipal.add(panelDeControl, BorderLayout.NORTH);
        scroll.setViewportView(visorHtml);
        panelPrincipal.add(scroll, BorderLayout.CENTER);
        contenedor.add(panelPrincipal);
    }

    /**
     * Crea el panel con el textField para escribir la url y el boton de ir
     *
     */
    private void creaPanelDeControl()
    {
        panelDeControl = new JPanel(new FlowLayout());
        editorUrl = new JTextField(50);
        botonIr = new JButton("Ir");
        panelDeControl.add(editorUrl);
        panelDeControl.add(botonIr);
    }
}
